program morsen;
uses Dos,Crt;
const maxcode1=4;
const Code1:array['A'..'Z',1..MaxCode1] of byte=(
  (0,1,2,2), {A}
  (1,0,0,0), {B}
  (1,0,1,0), {C}
  (1,0,0,2), {D}
  (0,2,2,2), {E}
  (0,0,1,0), {F}
  (1,1,0,2), {G}
  (0,0,0,0), {H}
  (0,0,2,2), {I}
  (0,1,1,1), {J}
  (1,0,1,2), {K}
  (0,1,0,0), {L}
  (1,1,2,2), {M}
  (1,0,2,2), {N}
  (1,1,1,2), {O}
  (0,1,1,0), {P}
  (1,1,0,1), {Q}
  (0,1,0,2), {R}
  (0,0,0,2), {S}
  (1,2,2,2), {T}
  (0,0,1,2), {U}
  (0,0,0,1), {V}
  (0,1,1,2), {W}
  (1,0,0,1), {X}
  (1,0,1,1), {Y}
  (1,1,0,0)  {Z}
);
const MaxCode2=5;
const Code2:array['0'..'9',1..MaxCode2] of byte=(
  (1,1,1,1,1), {0}
  (0,1,1,1,1), {1}
  (0,0,1,1,1), {2}
  (0,0,0,1,1), {3}
  (0,0,0,0,1), {4}
  (0,0,0,0,0), {5}
  (1,0,0,0,0), {6}
  (1,1,0,0,0), {7}
  (1,1,1,0,0), {8}
  (1,1,1,1,0) {9}
);
const maxcode=6;
type Tcode=array[1..maxcode] of byte;

procedure getcode(c:char;var h:Tcode);

  procedure makecode(a,b,c,d,e,f:byte;var h:Tcode);
  begin
    h[1]:=a;
    h[2]:=b;
    h[3]:=c;
    h[4]:=d;
    h[5]:=e;
    h[6]:=f;
  end;

var n:byte;
begin
  fillchar(h,sizeof(h),2);
  c:=upcase(c);
  if c in ['A'..'Z'] then begin
    for n:=1 to maxcode1 do h[n]:=code1[c,n];
  end else if c in ['0'..'9'] then begin
    for n:=1 to maxcode2 do h[n]:=code2[c,n];
  end else case c of
    '.','!':makecode(0,1,0,1,0,1,h);
    ',':makecode(1,1,0,0,1,1,h);
    ':':makecode(1,1,1,0,0,0,h);
    '-':makecode(1,0,0,0,0,1,h);
    '"','''','`':makecode(0,1,0,0,1,0,h);
    '''':makecode(0,1,1,1,1,0,h);
    '(',')','[',']','{','}':makecode(1,0,1,1,0,1,h);
    '?':makecode(0,0,1,1,0,0,h);
    '_':makecode(0,0,1,1,0,1,h);
    '|':makecode(1,0,0,0,1,2,h);
    '','':makecode(0,1,0,1,2,2,h);
    '','':makecode(0,0,1,1,2,2,h);
    '','':makecode(1,1,1,0,2,2,h);
    '':makecode(0,0,0,2,2,2,h);
    else write('Morsecode unbekannt von "',c,'"');
  end;
end;

type TChar=array[0..65534] of char;

OText=object
  t:pointer;
  size,aktword,aktbuchstabe:word;
  zufall,runde:boolean;
  constructor init;
  procedure load(name:string);
  destructor done;
  procedure reset;
  function ende:boolean;
{  procedure wortvor(n:word);
  procedure wortzurueck(n:word);
  procedure buchstabevor;
  procedure buchstabezurueck;
  procedure zufallswort;}
  function getbuchstabe(var c:char):boolean;
  function getwort(var s:string):boolean;
end;

OMorse=object
  punktlaenge,strichlaenge,pause,buchstabenpause,wortpause,tonhoehe:word;
  bild,blink,ton,geandert:boolean;
  gesch:real;
  constructor init;
  destructor done;
  function morsebuchstabe(c:char):string;
  function morsewort(s:string):string;
  procedure setup;
  procedure wait(n:word);
end;

constructor OText.Init;
begin
  zufall:=true;
  t:=nil;
end;

procedure OText.load(name:string);
var s:searchrec;
    m:byte;
    f:file;
begin  
  if name='' then begin
    zufall:=true;
    exit;
  end;
  if t<>nil then freemem(t,size);
  zufall:=false;
  findfirst(name,anyfile,s);
  if doserror<>0 then begin
    writeln('Datei '+name+' nicht gefunden!');
    delay(2000);
    zufall:=true;
    exit;
  end; 
  if s.size>65534 then begin
    size:=65534;
    writeln('Datei '+name+' kann nicht komplett geladen werden!');
    delay(1000);
  end else size:=s.size;
  assign(f,name);
  system.reset(f,1);
  getmem(t,size);
  blockread(f,t^,size);
  close(f);
  aktword:=0;
  aktbuchstabe:=0;
  runde:=false;
end;

destructor OText.done;
begin
  freemem(t,size);
end;

procedure otext.reset;
begin
  aktbuchstabe:=0;
  aktword:=0;
  runde:=false;
end;

function otext.ende;
begin
  ende:=runde;
end;

function buchstabe(c:char):boolean;
begin
  buchstabe:=c in ['A'..'Z','a'..'z','0'..'9','','','','','','','',
                   '.',',',':','-','''','`','(',')','?','"','_','|','!'];
end;
              
function OText.getbuchstabe(var c:char):boolean;
var en,ersterunde,stabe:boolean;
begin
  if zufall then begin
    c:=char(byte('A')+random(26));
    getbuchstabe:=true;
    exit;
  end;
  en:=false;
  ersterunde:=true;
  repeat
    c:=TChar(t^)[aktbuchstabe];
    inc(aktbuchstabe);
    if aktbuchstabe>size then begin
      if not ersterunde then begin
        writeln('Text zu kurz');
        halt(1);
      end;
      ersterunde:=false;
      aktbuchstabe:=0;
      runde:=true;
    end;
    stabe:=buchstabe(c);
    if not stabe then begin
      aktword:=aktbuchstabe;
    end else en:=true;    
  until en;
  getbuchstabe:=(aktbuchstabe=0) or (not buchstabe(TChar(t^)[aktbuchstabe]));
end;

function OText.getwort(var s:string):boolean;
var c:char;
begin
  s:='';
  while not getbuchstabe(c) do s:=s+c;
  s:=s+c;
  getwort:=aktbuchstabe=size;
end;

function fileexist(name:string):boolean;
var s:searchrec;
begin
  s.name:=name;
  findfirst(name,anyfile,s);
  fileexist:=doserror=0;
end;

constructor OMorse.init;
var f:text;
    s:string;
begin
  if fileexist('morse.ini') then begin
    assign(f,'morse.ini');
    reset(f);
    readln(f,punktlaenge);
    readln(f,strichlaenge);
    readln(f,pause);
    readln(f,buchstabenpause);
    readln(f,wortpause);
    readln(f,tonhoehe);
    readln(f,s);ton:=s='TRUE';
    readln(f,s);bild:=s='TRUE';
    readln(f,s);blink:=s='TRUE';
    readln(f,gesch);
    close(f);
  end else begin
    punktlaenge:=100;
    strichlaenge:=500;
    pause:=100;
    buchstabenpause:=500;
    wortpause:=1000;
    tonhoehe:=880;
    ton:=false;
    bild:=true;
    blink:=false;
    gesch:=1;
  end;
  geandert:=false;
  nosound;
end;

destructor OMorse.done;
var f:text;
begin
  if geandert then begin
    assign(f,'morse.ini');
    rewrite(f);
    writeln(f,punktlaenge);
    writeln(f,strichlaenge);
    writeln(f,pause);
    writeln(f,buchstabenpause);
    writeln(f,wortpause);
    writeln(f,tonhoehe);
    writeln(f,ton);
    writeln(f,bild);
    writeln(f,blink);
    writeln(f,gesch);
    close(f);
  end;
  nosound;
end;

procedure OMorse.wait(n:word);
begin
  delay(round(n*gesch));
end;

function OMorse.morsebuchstabe(c:char):string;
var n,altx,alty:byte;
    s:string;
    code:Tcode;

  procedure lampe(an:boolean);
  begin
    if an then begin
      gotoxy(altx-1,alty-1);
      write('');
      gotoxy(altx-1,alty);
      write('');
      gotoxy(altx-1,alty+1);
      write('');
    end else begin
      gotoxy(altx-1,alty-1);
      write('   ');
      gotoxy(altx-1,alty);
      write('   ');
      gotoxy(altx-1,alty+1);
      write('   ');
    end;
  end;

begin
  s:='';
  if not buchstabe(c) then exit;
  getcode(c,code);
  n:=1;
  altx:=wherex;
  alty:=wherey;  
  repeat
    if Code[n]=1 then begin
      s:=s+'-';
      if bild and (not blink) then write('-');      
      if blink then lampe(true);
      if ton then sound(tonhoehe);
      if blink or ton then wait(strichlaenge);
      if blink then lampe(false);
      if ton then nosound;
    end else begin
      if bild and (not blink) then write('.');
      if blink then lampe(true);
      if ton then sound(tonhoehe);
      if blink or ton then wait(punktlaenge);
      if blink then lampe(false);
      if ton then nosound;
      s:=s+'.';
    end;
    if ton or blink then wait(pause);
    inc(n);
  until (n>maxcode) or (Code[n]=2);
  if blink then gotoxy(altx,alty);
  if ton or blink then wait(buchstabenpause);
  if bild and (not blink) then write('  ');
  morsebuchstabe:=s+'  ';
end;

function OMorse.morsewort(s:string):string;
var n:byte;
    o:string;
begin
  o:='';
  for n:=1 to length(s) do o:=o+morsebuchstabe(s[n]);
  if blink or ton then wait(wortpause);
  if bild and (not blink) then write('     ');
  morsewort:=o+'     ';
end;

var Morse:OMorse;
    Tex:OText;
const randlinks:word=15;
      randoben:word=0;
      maxzeile:word=60;
      maxzeichen:word=135;

  procedure lernen(wort:boolean);
  var c:char;
      ein:char;
      altx,alty,n,m:word;
      richtig,falsch:word;
      ende,ok:boolean;
      aktwort:string;
      aktpos:byte;
      hour,min,sec,sec100:word;
      time,dt:longint;
  begin
    clrscr;
    altx:=1;
    alty:=7;
    richtig:=0;
    falsch:=0;
    ende:=false;
    gettime(hour,min,sec,sec100);
    time:=longint(hour)*3600+longint(min)*60+longint(sec);
    repeat
      aktpos:=1;
      if wort then tex.getwort(aktwort) 
      else begin
        ende:=tex.getbuchstabe(c);
        aktwort:=c;
      end;        
      gotoxy(1,4);write(' ':80);gotoxy(4,4);
      if not wort then morse.morsebuchstabe(c)
      else morse.morsewort(aktwort);
      ok:=true;
      m:=1;     
      while (m<=length(aktwort)) and (ein<>#27) do begin
        repeat until keypressed;
        while keypressed do ein:=upcase(readkey);
        if buchstabe(ein) then begin
          gotoxy(altx,alty);
          if ein=upcase(aktwort[m]) then textcolor(lightgreen)
          else textcolor(lightred);
          write(aktwort[m]);
          textcolor(yellow);
          altx:=wherex;
          alty:=wherey;
          if altx>70 then begin
            altx:=1;
            inc(alty);
          end;
          if alty>20 then begin
            alty:=7;
            altx:=1;
            for n:=7 to 21 do begin
              gotoxy(1,n);
              writeln('':80);
            end;
          end;
          ok:=ok and (ein=upcase(aktwort[m]));
          inc(m);
        end;
      end;
      if wort or ende then begin
        write(' ');
        altx:=wherex;
        alty:=wherey;
      end;
      gotoxy(1,1);
      if ok then begin
        textcolor(lightgreen);
        write('Richtig');
        inc(richtig);
      end else begin
        if not morse.ton then begin
          sound(100);
          delay(10);
          nosound;
        end else for n:=100 downto 50 do begin
          sound(n);
          delay(5);
        end;
        nosound;
        textcolor(lightred);
        write('Falsch ');
        inc(falsch);
      end;
      textcolor(yellow);
      gotoxy(10,1);
      if (richtig+falsch)<>0
      then writeln('Richtige:',richtig,' Falsche:',falsch,' Richtige ',richtig/(richtig+falsch)*100:3:1,'%      ');
      gettime(hour,min,sec,sec100);
      dt:=longint(hour)*3600+longint(min)*60+longint(sec)-time;
      if wort then write('Wrter pro Minute: ')
      else write('Zeichen pro Minute: ');
      if dt>0 then write('Richtige: ',(richtig)/dt*60:3:1,' Gesamt: ',
        (richtig+falsch)/dt*60:3:1,'   Gesamt: ',dt,' Sekunden ');
    until ein=#27;
  end;

  procedure getreal(var r:real;s:string);
  var s1:string;
      rh:real;
      err:integer;
  begin
    textcolor(lightgreen); write(s:30,'? ');
    textcolor(lightmagenta); write('[',r:8:4,']');
    readln(s1);
    if s1<>'' then begin
      val(s1,rh,err);
      if err=0 then r:=rh;
    end;
  end;


  procedure getword(var r:word;s:string);
  var s1:string;
      rh:word;
      err:integer;
  begin
    textcolor(lightgreen); write(s:30,'? ');
    textcolor(lightmagenta); write('[',r:8,']');
    readln(s1);
    if s1<>'' then begin
      val(s1,rh,err);
      if err=0 then r:=rh;
    end;
  end;

  procedure vorlesen;
  var p:byte;
      s:string;
  begin
    clrscr;
    writeln('*** Vorlesen ***');
    writeln;
    write('   ');
    p:=0;
    repeat
      tex.getwort(s);
      s:=morse.morsewort(s);
      if p+length(s)>60 then begin
        if morse.bild then writeln;
        p:=0;
      end;   
      inc(p,succ(length(s)));
    until keypressed;
  end;

  procedure Dateiliste;
  var s:searchrec;
  begin
    s.name:='*.*';
    findfirst('*.*',anyfile,s);
    while doserror=0 do begin
      write(s.name:20);
      findnext(s);
    end;
  end;

  procedure tofile;
  var o:text;
      name:string;
      p:byte;
      altbild,altblink,altton:boolean;
      s:string;
      zeile,n,seite:word;
  const pagebreak=#12;
  begin
    tex.reset;
    altton:=morse.ton;
    altblink:=morse.blink;
    altbild:=morse.bild;
    morse.ton:=false;
    morse.blink:=false;
    morse.bild:=false;
    clrscr;
    writeln('*** In Datei speichern ***');
    writeln;
    textcolor(lightmagenta);
    Dateiliste;
    textcolor(yellow);
    writeln;
    write('Gebe den Dateinamen an (oder PRN zum Drucken): ');
    readln(name);
    getword(randlinks,'linker Rand:');
    getword(randoben,'oberer Rand:');
    getword(maxzeile,'Zeilen pro Seite:');
    getword(maxzeichen,'Zeichen pro Zeile:');
    writeln;
    assign(o,name);
    rewrite(o);
    p:=0;
    seite:=0;
    zeile:=0;
    write(o,'':randlinks);
    repeat
      tex.getwort(s);
      if not tex.ende then begin
        s:=morse.morsewort(s);
        if p+length(s)>maxzeichen then begin
          writeln(o);
          write(o,'':randlinks);
          inc(zeile);
          if zeile>maxzeile then begin
            writeln(o,pagebreak);
            for n:=1 to randoben do writeln(o);
            write(o,'':randlinks);
            zeile:=0;
            inc(seite);
            gotoxy(1,wherey);
            write('Seite ',seite,' Zeichen: ',tex.aktbuchstabe,' Geschafft: ',tex.aktbuchstabe/tex.size*100:3:0,' %  ');
          end;
          p:=0;
        end;
        write(o,s+' ');
        inc(p,succ(length(s)));
      end;
    until tex.ende or keypressed;
    writeln(o);
    close(o);
    morse.ton:=altton;
    morse.blink:=altblink;
    morse.bild:=altbild;
  end;

procedure ladetext;
var name:string;
begin
  clrscr;
  writeln('*** Text laden ***');
  writeln;
  textcolor(lightmagenta);
  Dateiliste;
  textcolor(yellow);
  writeln;
  write('Gebe den Dateinamen an:');
  readln(name);
  writeln;
  tex.load(name);
end;


procedure OMorse.SetUp;
begin
  clrscr;
  writeln('*** Blinkgeschwindigkeit ***');
  writeln;
  getword(punktlaenge,'Punktlnge');
  getword(Strichlaenge,'Strichlnge');
  getword(Pause,'Pausenlnge');
  getword(BuchstabenPause,'BuchstabenPausenLnge');
  getword(wortPause,'WortPausenLnge');
  getword(tonhoehe,'TonHhe');
end;

procedure menu;
var ein:char;

  procedure an(b:boolean);
  begin
    if b then begin
      textcolor(lightgreen);
      writeln('an');
    end else begin
      textcolor(lightred);
      writeln('aus');
    end;
    textcolor(yellow);
  end;

begin
  ein:='?';
  repeat
    case ein of
      'A':lernen(false);
      'B':lernen(true);
      'C':vorlesen;
      'D':morse.ton:=not morse.ton;
      'E':morse.blink:=not morse.blink;
      'F':morse.bild:=not morse.bild;
      'G':morse.setup;
      'H':ladetext;
      'I':tex.zufall:=true;
      'J':tex.reset;
      'K':tofile;
      '+':morse.gesch:=morse.gesch*1.1;
      '-':morse.gesch:=morse.gesch*0.9;
    end;
    morse.geandert:=morse.geandert or (ein in ['D','E','F','G','+','-']);
    while keypressed do readkey;
    textbackground(blue);
    textcolor(yellow);
    clrscr;
    writeln('*** Morsen lernen ***');
    writeln;
    writeln;
    writeln('*** bungen ***');
    writeln('A) Buchstabe fuer Buchstabe');
    writeln('B) Wort fuer Wort');
    writeln('C) Vorlesen');
    writeln;
    writeln('*** Modus ***');
    write('D) Ton ');an(morse.ton);
    write('E) Blink ');an(morse.blink);
    write('F) Schrift ');an(morse.bild);
    writeln;
    writeln('*** Geschwindigkeit ***');
    writeln('G) Morse Geschwindigkeits Verhltnisse');
    writeln('+/-) Morsegeschwindigkeit schneller/langsamer (',morse.gesch:3:2,')');
    writeln;
    writeln('*** bungstext ***');
    writeln('H) Text laden');
    writeln('I) Zufallstext');
    writeln('J) Text von vorne');
    writeln('K) in Datei speichern');
    writeln;
    write('ESC) Ende');
    repeat until keypressed;
    while keypressed do ein:=upcase(readkey);
  until ein=#27;
end;

var ein:char;
begin
  randomize;
  tex.init;
  if paramcount<>0 then Tex.load(paramstr(1));
  morse.init;
  menu;
  morse.done;
end.
